package io.zipcoder.crudapp;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.xml.ws.Response;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

@RestController
public class PersonController {

    private Person person = new Person();
    private List<Person> personList = new ArrayList<>();

    @Autowired
    PersonRepository personRepository;

    @PostMapping(value = "/people")
    public ResponseEntity<?> createPerson(@RequestBody Person p){
        this.personRepository.save(p);

        return new ResponseEntity<>(this.personRepository.save(p), HttpStatus.CREATED);
    }

    @GetMapping(value = "/people/{id}")
    public ResponseEntity<?> getPerson(@PathVariable int id){

        return new ResponseEntity<>(personRepository.findOne(id), HttpStatus.OK);
    }

    @GetMapping(value = "/people")
    public ResponseEntity<?> getPersonList(){

        Iterator<Person> personIterator = personRepository.findAll().iterator();

        ArrayList<Person> newPersonList = new ArrayList<>();

        while(personIterator.hasNext()){
            newPersonList.add(personIterator.next());
        }

        return new ResponseEntity<>(personRepository.findAll(), HttpStatus.OK);
    }

    @PutMapping("/people/{id}")
    public ResponseEntity<?> updatePerson(@RequestBody Person p){

        return new ResponseEntity<>(personRepository.save(p), HttpStatus.OK);
    }

    @DeleteMapping("/people/{id}")
    public ResponseEntity<?> deletePerson(@PathVariable int id){
        personRepository.delete(id);
        return new ResponseEntity<>(HttpStatus.NO_CONTENT);
    }

}
